/*
 * Copyright © 2018 organization baomidou
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.baomidou.dynamic.datasource.enums;

/**
 * 动态数据源常量
 *
 * @author jobob
 * @since 2019-10-08
 */
public interface DdConstants {

    /**
     * 数据源：主库
     */
    String MASTER = "master";
    /**
     * 数据源：从库
     */
    String SLAVE = "slave";

    /**
     * DRUID数据源类
     */
    String DRUID_DATASOURCE = "com.alibaba.druid.pool.DruidDataSource";
    /**
     * HikariCp数据源
     */
    String HIKARI_DATASOURCE = "com.zaxxer.hikari.HikariDataSource";
    /**
     * BeeCp数据源
     */
    String BEECP_DATASOURCE = "cn.beecp.BeeDataSource";
    /**
     * DBCP2数据源
     */
    String DBCP2_DATASOURCE = "org.apache.commons.dbcp2.BasicDataSource";
    /**
     * Atomikos数据源
     */
    String ATOMIKOS_DATASOURCE = "com.atomikos.jdbc.AtomikosDataSourceBean";
    /**
     * C3P0数据源
     */
    String C3P0_DATASOURCE = "com.mchange.v2.c3p0.ComboPooledDataSource";
}